varying highp vec4 var_position;
varying mediump vec4 var_position_world;
varying highp vec3 var_normal;
varying highp vec2 var_texcoord0;

uniform highp sampler2D tex0;
uniform highp sampler2D tex1;
uniform highp vec4 fog_colour;

float get_fraction(float value, float min, float max)
{
    return clamp((value-max)/(min-max), 0.0, 1.0);
}

void main() {

    vec4 color = texture2D(tex0, var_texcoord0.xy);

    // Fade into background
    float distance = abs(var_position.y);
    lowp vec4 fog_colour_pm = vec4(fog_colour.xyz * fog_colour.a, fog_colour.a);
    float distance_multiplier = 2.0; // Needed for some reason
    float min = 25000.0 * distance_multiplier;
    float max = 10000.0 * distance_multiplier;
    float visibility_fraction = get_fraction(distance, min, max);
    fog_colour_pm.a = visibility_fraction;
    fog_colour_pm.rgb *= visibility_fraction; 
    color.rgb = fog_colour_pm.rgb + (color.rgb * (1.0 - fog_colour_pm.a));   
    color.a = fog_colour_pm.a + (color.a * (1.0 - fog_colour_pm.a));    
   
    gl_FragColor = color;
    
}
